summaryrefslogtreecommitdiff
path: root/meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh
diff options
context:
space:
mode:
authorGeorge Hung <george.hung@quantatw.com>2020-05-20 12:22:25 +0300
committerAndrew Geissler <geissonator@yahoo.com>2020-06-12 15:59:13 +0300
commitf089ba1b6aff10fcd4e7a6e4b9809e866e0816ff (patch)
treef9cad88e0b2a7512c21446f2d599782aa585e30a /meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh
parenta7cfc8dc0605f16e068e2ae66ed6e81ff3369c71 (diff)
downloadopenbmc-f089ba1b6aff10fcd4e7a6e4b9809e866e0816ff.tar.xz
meta-quanta: gbs: inband bmc/bios image update
gbs-bmc-update and gbs-bios-update packages do inband bmc/bios image update via Nuvoton PCI mailbox Tested: Set PCI mailbox memory space as writable ~# sudo setpci -d 1050:0750 04.B=02 bmc update: ~# sudo burn_my_bmc --command update --interface ipmipci --image image-bmc --sig image-bmc.sig --type image bios update: ~# sudo burn_my_bmc --command update --interface ipmipci --image image-bios --sig image-bios.sig --type bios (From meta-quanta rev: 85d9f2a992421ca981ac11c6227ceb3531a3bb1a) Signed-off-by: George Hung <george.hung@quantatw.com> Change-Id: I1a73f724c4cf16636c460d20c6efd409eac4e80f Signed-off-by: Andrew Geissler <geissonator@yahoo.com>
Diffstat (limited to 'meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh')
-rw-r--r--meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh84
1 files changed, 84 insertions, 0 deletions
diff --git a/meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh b/meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh
new file mode 100644
index 000000000..3a215fa50
--- /dev/null
+++ b/meta-quanta/meta-gbs/recipes-gbs/gbs-bios-update/files/bios-update.sh
@@ -0,0 +1,84 @@
+#!/bin/sh
+# Copyright 2020 Google LLC
+# Copyright 2020 Quanta Computer Inc.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# Global variables
+
+# GPIO to control the host SPI mux
+SPI_SW_SELECT=169
+
+# Kernel control string for bind/unbind
+KERNEL_FIU_ID="c0000000.fiu"
+
+# Kernel sysfs path for bind/unbind
+KERNEL_SYSFS_FIU="/sys/bus/platform/drivers/NPCM-FIU"
+
+IMAGE_FILE="/tmp/image-bios"
+
+# Taken from /run/initramfs/update
+# Given label name, return mtd node. e.g. `findmtd bmc` returns 'mtd0'
+findmtd() {
+ m=$(grep -xl "$1" /sys/class/mtd/*/name)
+ m=${m%/name}
+ m=${m##*/}
+ echo $m
+}
+
+cleanup() {
+ if [ -d "${KERNEL_SYSFS_FIU}/${KERNEL_FIU_ID}" ]; then
+ echo "${KERNEL_FIU_ID}" > "${KERNEL_SYSFS_FIU}"/unbind
+ fi
+ echo low > /sys/class/gpio/gpio${SPI_SW_SELECT}/direction # Switch mux to host
+ rm -f ${IMAGE_FILE}
+}
+trap cleanup EXIT SIGHUP SIGINT SIGTERM
+
+main() {
+ if [ ! -f ${IMAGE_FILE} ]; then
+ echo "Invalid bios image file!"
+ exit 1
+ fi
+
+ echo "Starting bios update..."
+ if [ ! -d "/sys/class/gpio/gpio${SPI_SW_SELECT}" ]; then
+ echo "${SPI_SW_SELECT}" > /sys/class/gpio/export
+ fi
+
+ echo high > /sys/class/gpio/gpio${SPI_SW_SELECT}/direction # Switch mux to BMC
+
+ if [ -d "${KERNEL_SYSFS_FIU}/${KERNEL_FIU_ID}" ]; then
+ echo "${KERNEL_FIU_ID}" > "${KERNEL_SYSFS_FIU}"/unbind
+ fi
+ echo "${KERNEL_FIU_ID}" > "${KERNEL_SYSFS_FIU}"/bind
+
+ # BIOS flash is labelled 'pnor'
+ pnor_mtd=$(findmtd pnor)
+ if [ -z "${pnor_mtd}" ]; then
+ echo "Cannot find bios flash mtd partition!"
+ exit 1
+ fi
+
+ flashcp -v $IMAGE_FILE /dev/"${pnor_mtd}"
+ if [ $? -eq 0 ]; then
+ echo "bios update successfully..."
+ else
+ echo "bios update failed..."
+ exit 1
+ fi
+}
+# Exit without running main() if sourced
+return 0 2>/dev/null
+
+main "$@"